#!/bin/sh


#we want to find free user to run simulation
export PREFIX="/opt"
export SCRIPTS_PATH="$PREFIX/scripts";
export TMP_DIR="/tmp/simu"
export STARTUP_PATH="$SCRIPTS_PATH/startup_user.sh"
export START_PORT=$1
export CONF_ID=$2
export SIMU_DURATINON=$3
export SIMU_USER=$4
export SIMU_USER_PREFIX="simu"
export SIMU_HOME="$PREFIX/users"
export RUN_USER=${SIMU_USER}_$START_PORT
export SIMU_PASSWORD=$5
export SIMU_GROUP=`cat /etc/group | grep '^simu:' | awk -F ':' '{print $3}'`
export SIMU_SHELL="$SCRIPTS_PATH/shell"
export SHUTDOWN_PATH="$SCRIPTS_PATH/shutdown.sh"
export CREATE_USERS_PATH="$SCRIPTS_PATH/create_users.sh"
export TIMEOUT_FOR_PORTS="35"


if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" -o -z "$5" ];then
	echo "Usage START_PORT CONF_ID SIMU_DURATINON LOGIN PASSWORD"
	exit 8;
fi

if [ -n "`netstat -l -n|grep $START_PORT`" ];then
	echo "Port in use !!!"
	exit 3;
fi

useradd -g $SIMU_GROUP -d $SIMU_HOME -s $SIMU_SHELL $RUN_USER > /dev/null 2>&1

echo "STRATUP: Running sudo -u $RUN_USER $STARTUP_PATH $START_PORT $CONF_ID "

/usr/bin/sudo -H -u "$RUN_USER" $STARTUP_PATH $START_PORT $CONF_ID 

if [ "$?" -ne 0 ];then
	$SHUTDOWN_PATH 0 $RUN_USER
	exit 13
fi;
echo "STRATUP:Running sudo $SHUTDOWN_PATH $SIMU_DURATINON $RUN_USER " 

$CREATE_USERS_PATH &
$SHUTDOWN_PATH $SIMU_DURATINON $RUN_USER & 

exit 0

