#!/bin/sh

echo "$TEST"

#parameters 1=starting_port 2=path to configuration 

PREFIX="/opt"
SCRIPTS_PATH="$PREFIX/scripts";
TMP_DIR="/tmp/simu/" #directory in which we can create temp files
if [ ! -d $TMP_DIR ];then mkdir $TMP_DIR; fi;
TMP_DIR="/tmp/simu/$USER/" #directory in which we can create temp files
if [ ! -d $TMP_DIR ];then mkdir $TMP_DIR; fi;
SIM_DIR=`mktemp -d -p $TMP_DIR` #we create directory to hold nescesary tmp data
VDE_PATH="" #path to vde_switch exutable
UML_PATH="$PREFIX/uml/linux" # path to uml linux exutable
UML_FS_PATH="$PREFIX/uml/root_fs_new" #
CONF_ID="$2" #configuration of network
PORT_START="$1"
GROUP="simu"

DYNAGEN_WRAPPER_PATH="$SCRIPTS_PATH/dynagen_wrapper"
DYNAGEN_PATH="/usr/bin/dynagen"
DYNAMPIS_PATH="/usr/bin/dynamips"
DYNAGENCONF_PATH=`mktemp -p $TMP_DIR`".net"
MYSQL_USER="vlab";
MYSQL_PASS="#VLAB#";
MYSQL_DB="vlab";
XML_OUTPUT=`mktemp -p $TMP_DIR`".xml"
CONF="`/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS $MYSQL_DB -r -L -N -e \"SELECT lab.configuration FROM lab,simulation WHERE simulation.id=$CONF_ID AND simulation.id_lab=lab.id;\" |grep -v '+-----'`"

echo "<?xml version=\"1.0\"?>" > $XML_OUTPUT
echo "<device_list>" >> $XML_OUTPUT
echo "<working_dir>$SIM_DIR</working_dir>" >> $XML_OUTPUT

if [ -z $VDE_PATH ]; then
	VDE_PATH="vde_switch"
fi
echo "createing tmp dir $SIM_DIR"
CON_PORT=$PORT_START;
cd $SIM_DIR
echo "$CONF" | while read line; do
	
	#change paths to coresponds with unix sockets and start uml hosts and vde switches
	if [ -n "`echo $line|egrep \"(f|fa)([0-9]/)+[0-9] = host\"`" ];then
		HOST_NAME=`echo $line | awk '{ print $3 }'`
		let CON_PORT=$CON_PORT+1;
		HOST_TMPDIR=`mktemp -d -p $SIM_DIR`
		echo "Executing $VDE_PATH -daemon -sock $HOST_TMPDIR/switch"
		$VDE_PATH -daemon -sock $HOST_TMPDIR/switch
		echo "Executing $UML_PATH ubda=$HOST_TMPDIR/cow,$UML_FS_PATH con1=port:$CON_PORT init=/etc/preinit eth0=daemon,,,$HOST_TMPDIR/switch/ctl"
		sleep 1;
		$UML_PATH "ubda=$HOST_TMPDIR/cow,$UML_FS_PATH con1=port:$CON_PORT init=/etc/preinit eth0=daemon,,,$HOST_TMPDIR/switch/ctl" </dev/null >/dev/null &
		line=`echo $line | sed -e "s@host@NIO_vde:$HOST_TMPDIR/switch/ctl:$HOST_TMPDIR/switch/dyna@g" `
		#generate xml output
		echo "<device>" >> $XML_OUTPUT
		echo "<type>host</type>" >> $XML_OUTPUT
		echo "<name>${HOST_NAME}</name>" >> $XML_OUTPUT
		echo "<port>$CON_PORT</port>" >> $XML_OUTPUT
		echo "</device>" >> $XML_OUTPUT
	fi
	
	if [ -n "`echo $line|egrep -i \"\[\[router\"`" ];then
		ROUTER_NAME=`echo $line | awk '{ print $2 }' | tr -d ']'`
	fi
	if [ -n "`echo $line|egrep \"console =\"`" ];then
		let CON_PORT=$CON_PORT+1;
		line="console = $CON_PORT"
		echo "<device>" >> $XML_OUTPUT
		echo "<type>router</type>" >> $XML_OUTPUT
		echo "<name>${ROUTER_NAME}</name>" >> $XML_OUTPUT
		echo "<port>$CON_PORT</port>" >> $XML_OUTPUT
		echo "</device>" >> $XML_OUTPUT
	fi
	if [ -n "`echo $line|egrep \"port =\"`" ];then
		line="port = $PORT_START"
	fi
	if [ -n "`echo $line|egrep \"workingdir =\"`" ];then
		line="workingdir = $SIM_DIR"
	fi

	# ingnore user defined udp port
	if [ -n "`echo $line|egrep \"udp =\"`" ];then
		continue;
	fi

	echo
	echo $line >> $DYNAGENCONF_PATH
	

	# change default upd port number
	if [ -n "`echo $line|egrep -i \"\[localhost\"`" ];then
		echo "udp = ${CON_PORT}" >> ${DYNAGENCONF_PATH}
		echo "port = ${CON_PORT}" >> ${DYNAGENCONF_PATH}
	fi
done

echo '>>> .net >>>'
echo $DYNAGENCONF_PATH 
cat $DYNAGENCONF_PATH 
echo '<<< .net <<<'

echo "</device_list>" >> $XML_OUTPUT

cd $SIM_DIR

echo "executing $DYNAMPIS_PATH -H $PORT_START"
$DYNAMPIS_PATH -H $PORT_START &
if [ ! "$?" -eq 0 ]; then
	exit -2;
fi;
COUNT=1 
while [ -z "`netstat -l -n|grep $PORT_START`" ];do
	echo "Waiting $COUNT s";
	if [ $COUNT -gt 20 ];then
		echo "Dynamips not started cannot continue"
		killall dynamips
		killall vde_switch
		killall linux
		exit 2;
	fi
	sleep 1;
	let COUNT=$COUNT+1;
done;

echo "$DYNAGEN_PATH $DYNAGENCONF_PATH" 
$DYNAGEN_WRAPPER_PATH $DYNAGEN_PATH  "$DYNAGENCONF_PATH" 
#hmm this part is wasting of time , cannot determine dynagen exit code
if [ ! "$?" -eq 0 ]; then
	exit 4;

fi;

DEVICE_LIST=`cat $XML_OUTPUT`

echo "Updatimg mysql"
#/usr/bin/mysql -u $MYSQL_USER --password=$MYSQL_PASS $MYSQL_DB -e "UPDATE simulation SET is_active=1, started=`date +%s` , uid='`whoami`', devices='$DEVICE_LIST' WHERE id=$CONF_ID ;"

chgrp $GROUP `ls -l $TMP_DIR | awk '{printf("%s %s\n",$3,"'$TMP_DIR'"$9)}' | grep $USER | awk '{print $2}'`
chmod g+w `ls -l $TMP_DIR | awk '{printf("%s %s\n",$3,"'$TMP_DIR'"$9)}' | grep $USER | awk '{print $2}'`

exit 0;
